// Final Demo Green Shield Box - Ported by MIDIMan
// Use with LUA_FBOX

/*
The green shield acted like a water shield until 2.0, where it behaved more like 
the elemental shield (without the passive ability). This shield was absent in 
1.09-1.09.4.
*/

freeslot(
	"SPR_FBXG",
	"MT_FDBOX_GREEN",
	"MT_FDBOX_GREEN_ICON",
	"S_FDBOX_GREEN_IDLE",
	"S_FDBOX_GREEN_ICON1",
	"S_FDBOX_GREEN_ICON2"
)

function A_FDGreenShield(actor, var1, var2)
	if not (actor and actor.valid) then return end
	
	if not actor.FDAltOption then
		// Give the player an elemental shield (2.0 behavior)
		A_GiveShield(actor, SH_ELEMENTAL, var2)
	elseif actor.FDAltOption >= 2 then
		// Give the player a bubble shield (1.01-1.08 behavior)
		A_GiveShield(actor, SH_BUBBLEWRAP, var2)
	end
end

addHook("MobjFuse", function(mobj)
	if not (mobj and mobj.valid) then return end
	
	P_FDMonitorFuseThink(mobj)
	return true
end, MT_FDBOX_GREEN)

addHook("MapThingSpawn", function(mobj, mthing)
	if not (mobj and mobj.valid
	and mthing and mthing.valid) then
		return
	end
	
	P_FDMonitorTypeSpawn(mobj, mthing)
	
	if mobj and mobj.valid then
		if ultimatemode and not G_IsSpecialStage(gamemap) then
			P_RemoveMobj(mobj)
		end
	end
end, MT_FDBOX_GREEN)

mobjinfo[MT_FDBOX_GREEN] = {
	//$Name Final Demo Green Shield
	//$Sprite FBXGA0
	//$Category Monitors
	//$Flags4Text Random (Strong)
	//$Flags8Text Random (Weak) / Random (Pre-2.0)
	//$ParameterText Behavior
	doomednum = 470,
	spawnstate = S_FDBOX_GREEN_IDLE,
	spawnhealth = 1,
	painstate = S_FDBOX_GREEN_IDLE,
	deathstate = S_FDBOX_EXPLOSION1,
	deathsound = sfx_pop,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	damage = MT_FDBOX_GREEN_ICON,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR|MF_GRENADEBOUNCE
}

states[S_FDBOX_GREEN_IDLE] =	{SPR_FBXG,	A,	2,	nil,	0,	0,	S_FDBOX_FLICKER}

mobjinfo[MT_FDBOX_GREEN_ICON] = {
	doomednum = -1,
	spawnstate = S_FDBOX_GREEN_ICON1,
	spawnhealth = 1,
	seesound = sfx_shield,
	speed = 4*FRACUNIT,	// Originally 2*FRACUNIT; Changed to match pre-2.1's speed
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	damage = 62*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON
}

states[S_FDBOX_GREEN_ICON1] =	{SPR_FBXG,	B,	18,	nil,				0,	0,	S_FDBOX_GREEN_ICON2}
states[S_FDBOX_GREEN_ICON2] =	{SPR_FBXG,	B,	18,	A_FDGreenShield,	0,	0,	S_NULL}
