// Final Demo Black Shield Box - Ported by MIDIMan
// Use with LUA_FBOX

/*
The black shield was the armagedddon shield all the way up to 2.0, where it 
became red.
*/

freeslot(
	"SPR_FBXK",
	"MT_FDBOX_BLACK",
	"MT_FDBOX_BLACK_ICON",
	"S_FDBOX_BLACK_IDLE",
	"S_FDBOX_BLACK_ICON1",
	"S_FDBOX_BLACK_ICON2"
)

addHook("MobjFuse", function(mobj)
	if not (mobj and mobj.valid) then return end
	
	P_FDMonitorFuseThink(mobj)
	return true
end, MT_FDBOX_BLACK)

addHook("MapThingSpawn", function(mobj, mthing)
	if not (mobj and mobj.valid
	and mthing and mthing.valid) then
		return
	end
	
	P_FDMonitorTypeSpawn(mobj, mthing)
	
	if mobj and mobj.valid then
		if ultimatemode and not G_IsSpecialStage(gamemap) then
			P_RemoveMobj(mobj)
		end
	end
end, MT_FDBOX_BLACK)

mobjinfo[MT_FDBOX_BLACK] = {
	//$Name Final Demo Black Shield
	//$Sprite FBXKA0
	//$Category Monitors
	//$Flags4Text Random (Strong)
	//$Flags8Text Random (Weak) / Random (Pre-2.0)
	//$ParameterText Behavior
	doomednum = 471,
	spawnstate = S_FDBOX_BLACK_IDLE,
	spawnhealth = 1,
	painstate = S_FDBOX_BLACK_IDLE,
	deathstate = S_FDBOX_EXPLOSION1,
	deathsound = sfx_pop,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	damage = MT_FDBOX_BLACK_ICON,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR|MF_GRENADEBOUNCE
}

states[S_FDBOX_BLACK_IDLE] =	{SPR_FBXK,	A,	2,	nil,	0,	0,	S_FDBOX_FLICKER}

mobjinfo[MT_FDBOX_BLACK_ICON] = {
	doomednum = -1,
	spawnstate = S_FDBOX_BLACK_ICON1,
	spawnhealth = 1,
	seesound = sfx_shield,
	speed = 4*FRACUNIT,	// Originally 2*FRACUNIT; Changed to match pre-2.1's speed
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	damage = 62*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON
}

states[S_FDBOX_BLACK_ICON1] =	{SPR_FBXK,	B,	18,	nil,			0,				0,	S_FDBOX_BLACK_ICON2}
states[S_FDBOX_BLACK_ICON2] =	{SPR_FBXK,	B,	18,	A_GiveShield,	SH_ARMAGEDDON,	0,	S_NULL}
